=== modified file 'NEWS'
--- NEWS	2005-10-14 05:34:49 +0000
+++ NEWS	2005-10-14 10:37:07 +0000
@@ -8,6 +8,9 @@
 
     * 'bzr add' no longer takes a --verbose option, and a --quiet option
       has been added that suppresses all output.
+
+    * Improved zsh completion support in contrib/zsh, from Clint
+      Adams.
     
   INTERNALS:
 

=== modified file 'contrib/zsh/_bzr'
--- contrib/zsh/_bzr	2005-05-09 04:30:00 +0000
+++ contrib/zsh/_bzr	2005-10-14 10:37:07 +0000
@@ -9,13 +9,12 @@
 # how to get zsh to reload this file when it changes, other than by
 # starting a new zsh.
 
-# This is not very useful at the moment because it only completes on
-# commands and breaks filename expansion for other arguments.
-
-
-_arguments -S "1::bzr command:($(bzr help commands | grep -v '^   '))"
-
-
-# Local variables:
-# mode: shell-script
-# End:
+local _bzr_subcommands expl curcontext="$curcontext"
+
+_bzr_subcommands=(${(f)"$(_call_program bzr bzr shell-complete)"})
+
+if (( CURRENT == 2 )); then
+  _describe -t subcommand 'subcommand' _bzr_subcommands
+else
+# this part missing
+fi

